      subroutine p4grads
c prepare the control file for GRADS

c===================================================================
c NOTE: need to update the number of VARS whenever change anything
c ===================================================================
      implicit none
      include 'couple.h'
      include 'atmosphere.h'
      include 'ocean.h'
      include 'seaice.h'
      include 'landice.h'

      OPEN(13,FILE=FILCNT,form='formatted')
C
      WRITE(13,91) filplt
91    FORMAT('DSET   ^',a20)
      WRITE(13,92)
92    FORMAT('TITLE  couple model ')
      WRITE(13,93) 
93    FORMAT('UNDEF  -999.0')
      WRITE(13,94)  12,1,1
94    FORMAT('XDEF   ',I3,'   LINEAR ',I3,'  ',I3)
      WRITE(13,95)  1,1,1
95    FORMAT('YDEF   ',I3,'   LINEAR ',I3,'  ',I3)
      WRITE(13,96)  1,1,1
96    FORMAT('ZDEF   ',I3,'   LINEAR ',I3,' ',I3)
      if (ndprin.le.365) then
      WRITE(13,97) NDAT,NDPRIN
      else
      WRITE(13,97) NDAT,NDPRIN/365
      endif
97    FORMAT('TDEF   ',I7,'   LINEAR ','JAN2000','  ',I5,'dy')
      WRITE(13,98)   275
98    FORMAT('VARS   ',I6)  
C
C =======================================================================
C     WRITE NAME OF VARIABLES
C =======================================================================
C
      WRITE(13,'(a24)') 'Teta1    0  99  Teta1   '
      WRITE(13,'(a24)') 'Teta2    0  99  Teta2   '
      WRITE(13,'(a24)') 'Teta3    0  99  Teta3   '
      WRITE(13,'(a24)') 'Teta4    0  99  Teta4   '
      WRITE(13,'(a24)') 'Hao1     0  99  Hao1    '
      WRITE(13,'(a24)') 'Hao2     0  99  Hao2    '
      WRITE(13,'(a24)') 'Hao3     0  99  Hao3    '
      WRITE(13,'(a24)') 'Hao4     0  99  Hao4    '
      WRITE(13,'(a24)') 'Hout1    0  99  Hout1   '
      WRITE(13,'(a24)') 'Hout2    0  99  Hout2   '
      WRITE(13,'(a24)') 'Hout3    0  99  Hout3   '
      WRITE(13,'(a24)') 'Hout4    0  99  Hout4   '
      WRITE(13,'(a24)') 'Hin1     0  99  Hin1    '
      WRITE(13,'(a24)') 'Hin2     0  99  Hin2    '
      WRITE(13,'(a24)') 'Hin3     0  99  Hin3    '
      WRITE(13,'(a24)') 'Hin4     0  99  Hin4    '
      WRITE(13,'(a24)') 'tflux1   0  99  tflux1  '
      WRITE(13,'(a24)') 'tflux2   0  99  tflux2  '
      WRITE(13,'(a24)') 'tflux3   0  99  tflux3  '
      WRITE(13,'(a24)') 'tflux4   0  99  tflux4  '
      WRITE(13,'(a24)') 'sflux1   0  99  sflux1  '
      WRITE(13,'(a24)') 'sflux2   0  99  sflux2  '
      WRITE(13,'(a24)') 'sflux3   0  99  sflux3  '
      WRITE(13,'(a24)') 'sflux4   0  99  sflux4  '
      WRITE(13,'(a24)') 'FWAO1    0  99  FWAO1   '
      WRITE(13,'(a24)') 'FWAO2    0  99  FWAO2   '
      WRITE(13,'(a24)') 'FWAO3    0  99  FWAO3   '
      WRITE(13,'(a24)') 'FWAO4    0  99  FWAO4   '
      WRITE(13,'(a24)') 'FT21     0  99  FT21    '
      WRITE(13,'(a24)') 'FT23     0  99  FT32    '
      WRITE(13,'(a24)') 'FT34     0  99  FT43    '
      WRITE(13,'(a24)') 'FW21     0  99  FW21    '
      WRITE(13,'(a24)') 'FW23     0  99  FW23    '
      WRITE(13,'(a24)') 'FW34     0  99  FW34    '
      WRITE(13,'(a24)') 'FW1      0  99  FW1     '
      WRITE(13,'(a24)') 'FW4      0  99  FW4     '
      WRITE(13,'(a24)') 't1       0  99  t1      '
      WRITE(13,'(a24)') 't2       0  99  t2      '
      WRITE(13,'(a24)') 't3       0  99  t3      '
      WRITE(13,'(a24)') 't4       0  99  t4      '
      WRITE(13,'(a24)') 't5       0  99  t5      '
      WRITE(13,'(a24)') 't6       0  99  t6      '
      WRITE(13,'(a24)') 't7       0  99  t7      '
      WRITE(13,'(a24)') 't8       0  99  t8      '
      WRITE(13,'(a24)') 's1       0  99  s1      '
      WRITE(13,'(a24)') 's2       0  99  s2      '
      WRITE(13,'(a24)') 's3       0  99  s3      '
      WRITE(13,'(a24)') 's4       0  99  s4      '
      WRITE(13,'(a24)') 's5       0  99  s5      '
      WRITE(13,'(a24)') 's6       0  99  s6      '
      WRITE(13,'(a24)') 's7       0  99  s7      '
      WRITE(13,'(a24)') 's8       0  99  s8      '
      WRITE(13,'(a24)') 'sigmaT1  0  99  sigmaT1 '
      WRITE(13,'(a24)') 'sigmaT2  0  99  sigmaT2 '
      WRITE(13,'(a24)') 'sigmaT3  0  99  sigmaT3 '
      WRITE(13,'(a24)') 'sigmaT4  0  99  sigmaT4 '
      WRITE(13,'(a24)') 'sigmaT5  0  99  sigmaT5 '
      WRITE(13,'(a24)') 'sigmaT6  0  99  sigmaT6 '
      WRITE(13,'(a24)') 'sigmaT7  0  99  sigmaT7 '
      WRITE(13,'(a24)') 'sigmaT8  0  99  sigmaT8 '
      WRITE(13,'(a24)') 'rhos1    0  99  rhos1   '
      WRITE(13,'(a24)') 'rhos2    0  99  rhos2   '
      WRITE(13,'(a24)') 'rhos3    0  99  rhos3   '
      WRITE(13,'(a24)') 'rhos4    0  99  rhos4   '
      WRITE(13,'(a24)') 'rhos5    0  99  rhos5   '
      WRITE(13,'(a24)') 'rhos6    0  99  rhos6   '
      WRITE(13,'(a24)') 'rhos7    0  99  rhos7   '
      WRITE(13,'(a24)') 'rhos8    0  99  rhos8   '
      WRITE(13,'(a24)') 'rhot1    0  99  rhot1   '
      WRITE(13,'(a24)') 'rhot2    0  99  rhot2   '
      WRITE(13,'(a24)') 'rhot3    0  99  rhot3   '
      WRITE(13,'(a24)') 'rhot4    0  99  rhot4   '
      WRITE(13,'(a24)') 'rhot5    0  99  rhot5   '
      WRITE(13,'(a24)') 'rhot6    0  99  rhot6   '
      WRITE(13,'(a24)') 'rhot7    0  99  rhot7   '
      WRITE(13,'(a24)') 'rhot8    0  99  rhot8   '
      WRITE(13,'(a24)') 'q21      0  99  q21     '
      WRITE(13,'(a24)') 'q34      0  99  q34     '
      WRITE(13,'(a24)') 'q23      0  99  q23     '
      WRITE(13,'(a24)') 'q62      0  99  q62     '
      WRITE(13,'(a24)') 'q73      0  99  q73     '
      WRITE(13,'(a24)') 'q76      0  99  q76     '
      WRITE(13,'(a24)') 'q56      0  99  q56     '
      WRITE(13,'(a24)') 'q87      0  99  q87     '
      WRITE(13,'(a24)') 'fsi1     0  99  fsi1    '
      WRITE(13,'(a24)') 'fsi4     0  99  fsi4    '
      WRITE(13,'(a24)') 'fi1      0  99  fi1     '
      WRITE(13,'(a24)') 'fi4      0  99  fi4     '
      WRITE(13,'(a24)') 'q1       0  99  q1      '
      WRITE(13,'(a24)') 'q2       0  99  q2      '
      WRITE(13,'(a24)') 'q3       0  99  q3      '
      WRITE(13,'(a24)') 'q4       0  99  q4      '
      WRITE(13,'(a24)') 'Tav      0  99  Tav     '
      WRITE(13,'(a24)') 'Tetaav   0  99  Tetaav  '
      WRITE(13,'(a24)') 'Sav      0  99  Sav     '
      WRITE(13,'(a24)') 'ImS      0  99  ImS     '
      WRITE(13,'(a24)') 'ImN      0  99  ImN     '
      WRITE(13,'(a24)') 'Iflow1   0  99  Iflow1  '
      WRITE(13,'(a24)') 'Iflow4   0  99  Iflow4  '
      WRITE(13,'(a24)') 'InewS    0  99  InewS   '
      WRITE(13,'(a24)') 'InewN    0  99  InewN   '
      WRITE(13,'(a24)') 'IceHs    0  99  IceHs   '
      WRITE(13,'(a24)') 'IceHn    0  99  IceHn   '
      WRITE(13,'(a24)') 'IceVolS  0  99  IVols   '
      WRITE(13,'(a24)') 'IceVolN  0  99  IVoln   '
      WRITE(13,'(a24)') 'al1      0  99  albedo1 '
      WRITE(13,'(a24)') 'al2      0  99  albedo2 '
      WRITE(13,'(a24)') 'al3      0  99  albedo3 '
      WRITE(13,'(a24)') 'al4      0  99  albedo4 '
      WRITE(13,'(a24)') 'Idepth1  0  99  Idepth1 '
      WRITE(13,'(a24)') 'Idepth4  0  99  Idepth4 '
      WRITE(13,'(a24)') 'Imelt1   0  99  Imelt1  '
      WRITE(13,'(a24)') 'Imelt4   0  99  Imelt4  '
      WRITE(13,'(a24)') 'Inewf1   0  99  Inewf1  '
      WRITE(13,'(a24)') 'Inewf4   0  99  Inewf4  '
      WRITE(13,'(a24)') 'Ipnew1   0  99  Ipnew1  '
      WRITE(13,'(a24)') 'Ipnew4   0  99  Ipnew4  '
      WRITE(13,'(a24)') 'solar1   0  99  solar1  '
      WRITE(13,'(a24)') 'solar2   0  99  solar2  '
      WRITE(13,'(a24)') 'solar3   0  99  solar3  '
      WRITE(13,'(a24)') 'solar4   0  99  solar4  '
      WRITE(13,'(a24)') 'q21s     0  99  q21s    '
      WRITE(13,'(a24)') 'q21t     0  99  q21t    '
      WRITE(13,'(a24)') 'q23s     0  99  q23s    '
      WRITE(13,'(a24)') 'q23t     0  99  q23t    '
      WRITE(13,'(a24)') 'q34s     0  99  q34s    '
      WRITE(13,'(a24)') 'q34t     0  99  q34t    '
      WRITE(13,'(a24)') 'Havail1  0  99  Havail1 '
      WRITE(13,'(a24)') 'Havail4  0  99  Havail4 '
      WRITE(13,'(a24)') 'Hneed1   0  99  Hneed1  '
      WRITE(13,'(a24)') 'Hneed4   0  99  Hneed4  '
      WRITE(13,'(a24)') 'sivol1   0  99  sivol1  '
      WRITE(13,'(a24)') 'sivol4   0  99  sivol4  '
      WRITE(13,'(a24)') 'LIdiff1  0  99  LIdiff1 '
      WRITE(13,'(a24)') 'LIdiff4  0  99  LIdiff4 '
      WRITE(13,'(a24)') 'LsIdiff1 0  99  LsIdiff1'
      WRITE(13,'(a24)') 'LsIdiff4 0  99  LsIdiff4'
      WRITE(13,'(a24)') 'InewN2   0  99  InewN2  '
      WRITE(13,'(a24)') 'Hlh1     0  99  Hlh1    '
      WRITE(13,'(a24)') 'Hlh2     0  99  Hlh2    '
      WRITE(13,'(a24)') 'Hlh3     0  99  Hlh3    '
      WRITE(13,'(a24)') 'Hlh4     0  99  Hlh4    '

      WRITE(13,'(a24)') 'CO2a     0  99  CO2a    '
      WRITE(13,'(a24)') 'CTav     0  99  CTav    '
      WRITE(13,'(a24)') 'PO4av    0  99  PO4av   '
      WRITE(13,'(a24)') 'ATav     0  99  ATav    '
      WRITE(13,'(a24)') 'sprod    0  99  sprod   '
      WRITE(13,'(a24)') 'hprod    0  99  hprod   '
      WRITE(13,'(a24)') 'totprod  0  99  totprod '

      WRITE(13,'(a24)') 'CT1      0  99  CT1     '
      WRITE(13,'(a24)') 'CT2      0  99  CT2     '
      WRITE(13,'(a24)') 'CT3      0  99  CT3     '
      WRITE(13,'(a24)') 'CT4      0  99  CT4     '
      WRITE(13,'(a24)') 'CT5      0  99  CT5     '
      WRITE(13,'(a24)') 'CT6      0  99  CT6     '
      WRITE(13,'(a24)') 'CT7      0  99  CT7     '
      WRITE(13,'(a24)') 'CT8      0  99  CT8     '

      WRITE(13,'(a24)') 'AT1      0  99  AT1     '
      WRITE(13,'(a24)') 'AT2      0  99  AT2     '
      WRITE(13,'(a24)') 'AT3      0  99  AT3     '
      WRITE(13,'(a24)') 'AT4      0  99  AT4     '
      WRITE(13,'(a24)') 'AT5      0  99  AT5     '
      WRITE(13,'(a24)') 'AT6      0  99  AT6     '
      WRITE(13,'(a24)') 'AT7      0  99  AT7     '
      WRITE(13,'(a24)') 'AT8      0  99  AT8     '

      WRITE(13,'(a24)') 'HCO31    0  99  HCO31   '
      WRITE(13,'(a24)') 'HCO32    0  99  HCO32   '
      WRITE(13,'(a24)') 'HCO33    0  99  HCO33   '
      WRITE(13,'(a24)') 'HCO34    0  99  HCO34   '
      WRITE(13,'(a24)') 'HCO35    0  99  HCO35   '
      WRITE(13,'(a24)') 'HCO36    0  99  HCO36   '
      WRITE(13,'(a24)') 'HCO37    0  99  HCO37   '
      WRITE(13,'(a24)') 'HCO38    0  99  HCO38   '

      WRITE(13,'(a24)') 'co31     0  99  co31    '
      WRITE(13,'(a24)') 'co32     0  99  co32    '
      WRITE(13,'(a24)') 'co33     0  99  co33    '
      WRITE(13,'(a24)') 'co34     0  99  co34    '
      WRITE(13,'(a24)') 'co35     0  99  co35    '
      WRITE(13,'(a24)') 'co36     0  99  co36    '
      WRITE(13,'(a24)') 'co37     0  99  co37    '
      WRITE(13,'(a24)') 'co38     0  99  co38    '

      WRITE(13,'(a24)') 'co21     0  99  co21    '
      WRITE(13,'(a24)') 'co22     0  99  co22    '
      WRITE(13,'(a24)') 'co23     0  99  co23    '
      WRITE(13,'(a24)') 'co24     0  99  co24    '
      WRITE(13,'(a24)') 'co25     0  99  co25    '
      WRITE(13,'(a24)') 'co26     0  99  co26    '
      WRITE(13,'(a24)') 'co27     0  99  co27    '
      WRITE(13,'(a24)') 'co28     0  99  co28    '

      WRITE(13,'(a24)') 'co2aa1   0  99  co2aa1  '
      WRITE(13,'(a24)') 'co2aa2   0  99  co2aa2  '
      WRITE(13,'(a24)') 'co2aa3   0  99  co2aa3  '
      WRITE(13,'(a24)') 'co2aa4   0  99  co2aa4  '
      WRITE(13,'(a24)') 'co2aa5   0  99  co2aa5  '
      WRITE(13,'(a24)') 'co2aa6   0  99  co2aa6  '
      WRITE(13,'(a24)') 'co2aa7   0  99  co2aa7  '
      WRITE(13,'(a24)') 'co2aa8   0  99  co2aa8  '      


      WRITE(13,'(a24)') 'ctflux1  0  99  ctflux1 '
      WRITE(13,'(a24)') 'ctflux2  0  99  ctflux2 '
      WRITE(13,'(a24)') 'ctflux3  0  99  ctflux3 '
      WRITE(13,'(a24)') 'ctflux4  0  99  ctflux4 '

      WRITE(13,'(a24)') 'a1       0  99  a1      '
      WRITE(13,'(a24)') 'a2       0  99  a2      '
      WRITE(13,'(a24)') 'a3       0  99  a3      '
      WRITE(13,'(a24)') 'a4       0  99  a4      '
      WRITE(13,'(a24)') 'a5       0  99  a5      '
      WRITE(13,'(a24)') 'a6       0  99  a6      '
      WRITE(13,'(a24)') 'a7       0  99  a7      '
      WRITE(13,'(a24)') 'a8       0  99  a8      '


      WRITE(13,'(a24)') 'po41     0  99  po41    '
      WRITE(13,'(a24)') 'po42     0  99  po42    '
      WRITE(13,'(a24)') 'po43     0  99  po43    '
      WRITE(13,'(a24)') 'po44     0  99  po44    '
      WRITE(13,'(a24)') 'po45     0  99  po45    '
      WRITE(13,'(a24)') 'po46     0  99  po46    '
      WRITE(13,'(a24)') 'po47     0  99  po47    '
      WRITE(13,'(a24)') 'po48     0  99  po48    '

      WRITE(13,'(a24)') 'rain1    0  99  rain1   '
      WRITE(13,'(a24)') 'rain2    0  99  rain2   '
      WRITE(13,'(a24)') 'rain3    0  99  rain3   '
      WRITE(13,'(a24)') 'rain4    0  99  rain4   '
      WRITE(13,'(a24)') 'rain5    0  99  rain5   '
      WRITE(13,'(a24)') 'rain6    0  99  rain6   '
      WRITE(13,'(a24)') 'rain7    0  99  rain7   '
      WRITE(13,'(a24)') 'rain8    0  99  rain8   '

      WRITE(13,'(a24)') 'prod1    0  99  prod1   '
      WRITE(13,'(a24)') 'prod2    0  99  prod2   '
      WRITE(13,'(a24)') 'prod3    0  99  prod3   '
      WRITE(13,'(a24)') 'prod4    0  99  prod4   '
      WRITE(13,'(a24)') 'prod5    0  99  prod5   '
      WRITE(13,'(a24)') 'prod6    0  99  prod6   '
      WRITE(13,'(a24)') 'prod7    0  99  prod7   '
      WRITE(13,'(a24)') 'prod8    0  99  prod8   '

      WRITE(13,'(a24)') 'tf21     0  99  tf21    '
      WRITE(13,'(a24)') 'tf15     0  99  tf15    '
      WRITE(13,'(a24)') 'tdf21    0  99  tdf21   '
      WRITE(13,'(a24)') 'tdf15    0  99  tdf15   '

      WRITE(13,'(a24)') 'vmix1    0  99  vmix1   '
      WRITE(13,'(a24)') 'vmix2    0  99  vmix2   '
      WRITE(13,'(a24)') 'vmix3    0  99  vmix3   '
      WRITE(13,'(a24)') 'vmix4    0  99  vmix4   '

      WRITE(13,'(a24)') 'redc1    0  99  redc1   '
      WRITE(13,'(a24)') 'redc2    0  99  redc2   '
      WRITE(13,'(a24)') 'redc3    0  99  redc3   '
      WRITE(13,'(a24)') 'redc4    0  99  redc4   '

      WRITE(13,'(a24)') 'ctf21    0  99 ctf21     '
      WRITE(13,'(a24)') 'ctf15    0  99 ctf15     '
      WRITE(13,'(a24)') 'ctf56    0  99 ctf56     '
      WRITE(13,'(a24)') 'ctf34    0  99 ctf34     '
      WRITE(13,'(a24)') 'ctf48    0  99 ctf48     '
      WRITE(13,'(a24)') 'ctf87    0  99 ctf87     '
      WRITE(13,'(a24)') 'ctf62    0  99 ctf62     '
      WRITE(13,'(a24)') 'ctf73    0  99 ctf73     '

      WRITE(13,'(a24)') 'ctdf15    0  99 ctdf15  '
      WRITE(13,'(a24)') 'ctdf26    0  99 ctdf26    '
      WRITE(13,'(a24)') 'ctdf48    0  99 ctdf48    '
      WRITE(13,'(a24)') 'ctdf12    0  99 ctdf12    '
      WRITE(13,'(a24)') 'ctdf34    0  99 ctdf34    '
      WRITE(13,'(a24)') 'ctdf56    0  99 ctdf56    '
      WRITE(13,'(a24)') 'ctdf78    0  99 ctdf78    '

      WRITE(13,'(a24)') 'po4f21    0  99 po4f21     '
      WRITE(13,'(a24)') 'po4f15    0  99 po4f15     '
      WRITE(13,'(a24)') 'po4f56    0  99 po4f56     '
      WRITE(13,'(a24)') 'po4f34    0  99 po4f34     '
      WRITE(13,'(a24)') 'po4f48    0  99 po4f48     '
      WRITE(13,'(a24)') 'po4f87    0  99 po4f87     '
      WRITE(13,'(a24)') 'po4f62    0  99 po4f62     '
      WRITE(13,'(a24)') 'po4f73    0  99 po4f73     '

      WRITE(13,'(a24)') 'po4df15    0  99 po4df15  '
      WRITE(13,'(a24)') 'po4df26    0  99 po4df26    '
      WRITE(13,'(a24)') 'po4df48    0  99 po4df48    '
      WRITE(13,'(a24)') 'po4df12    0  99 po4df12    '
      WRITE(13,'(a24)') 'po4df34    0  99 po4df34    '
      WRITE(13,'(a24)') 'po4df56    0  99 po4df56    '
      WRITE(13,'(a24)') 'po4df78    0  99 po4df78    '      

 
C?=======================================================================
      WRITE(13,99) 
99    FORMAT('ENDVARS')
      CLOSE(13)

      return
      end
